/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.def.element;

import java.io.Serializable;
import java.util.Map;

/**
 * Multi-instantiatio definition within Activity element.
 */
public interface MultiInstantiationDefinition extends Serializable {

  /**
   * Java class name is called to retrieve the multiInstantiatorClass descriptor
   * @return The name of the class used for the multi instantiation.
   */
  String getClassName();
  /**
   * Possibility to give parameters to the multiInstantiatorClass.<br>
   * Not supported.
   */
  Map<String, String> getParameters();
  /**
   * Name of the variable which will be assigned a different value
   * (to make a distinction between instances)
   */
  String getVariableId();
}


